/*------------------------------------------------------------------
libcscufl.c
Copyright 2012 Leonardo Lenoci <leonardo.lenoci@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------- */

#include "cscufl.h"

/* FUNCTIONS */

/* -------------------------------------------------------------------------------- */
cscufl_buffer*
cscufl_calloc(){
  
  cscufl_buffer* buff;

  buff=(cscufl_buffer*)calloc(1,sizeof(cscufl_buffer));
  if(buff == NULL){
    /* insert error handler here */
    return(NULL);
  }
  
  return(buff);
}
/* -------------------------------------------------------------------------------- */
void
cscufl_free(cscufl_buffer* buff){

  free(buff);
 
}
/* -------------------------------------------------------------------------------- */
cscufl_FILE*
cscufl_fopen(char *filename)
{
  
  cscufl_FILE* pfile;

  pfile=fopen(filename,"w");

  return pfile;

}
/* -------------------------------------------------------------------------------- */
void
cscufl_fclose(cscufl_FILE* pfile)
{
 
 fclose(pfile);

}
/* -------------------------------------------------------------------------------- */
int 
cscufl_check_buffer(cscufl_buffer* buff)
{
  char *message="you are writing outside the boundaries!";

  if (buff->res >= MAX_CSCUFL_BUFFER){
    cscufl_err(message);
    return(EXIT_FAILURE);
  }

  return(EXIT_SUCCESS);
}
/* -------------------------------------------------------------------------------- */
void
cscufl_rshell_inout(cscufl_buffer* buff, int num_ports, rshell_port_t* port, cscufl_bool inout)
{

  int i=0;

  switch(inout){
  case true:
    cscufl_write(buff,"<s:rshellInputPortList>\n");
    while (i<num_ports){
      cscufl_write(buff,"<s:rshellInputPort s:syntacticType=\"%s\" s:symanticType=\"%s\">%s</s:rshellInputPort>\n",(port+i)->syn_t,(port+i)->sym_t,(port+i)->name);
      i++;
    }
    if (cscufl_check_buffer(buff)) exit(EXIT_FAILURE);
    cscufl_write(buff,"</s:rshellInputPortList>\n");
    break;
  case false:
    cscufl_write(buff,"<s:rshellOutputPortList>\n");
    while (i<num_ports){
      cscufl_write(buff,"<s:rshellOutputPort s:syntacticType=\"%s\" s:symanticType=\"%s\">%s</s:rshellOutputPort>\n",(port+i)->syn_t,(port+i)->sym_t,(port+i)->name);
      i++;
    }
    if (cscufl_check_buffer(buff)) exit(EXIT_FAILURE);
    cscufl_write(buff,"</s:rshellOutputPortList>\n");
    cscufl_write(buff,"</s:rshell>\n</s:processor>\n");
    break;
  default:
    cscufl_err("Gotta specify a valid cscufl_bool!\n");exit(EXIT_FAILURE);
    break;
  }
  
  


  return;
}
